// TsPacketParser.cpp: CTsPacketParser NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TsPacketParser.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define TS_HEADSYNCBYTE		(0x47U)


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////


CTsPacketParser::CTsPacketParser()
	: IMediaDecoder()
	, m_dwErrorPacketCount(0UL)
	, m_dwValidPacketCount(0UL)
{
	// pPbgAJE^
	::FillMemory(m_abyContCounter, sizeof(m_abyContCounter), 0x10UL);

	// o̓pPbg𐶐
	m_pOutputPacket = new CTsPacket();
}

CTsPacketParser::~CTsPacketParser()
{
	if(m_pOutputPacket){
		m_pOutputPacket->Delete();
		m_pOutputPacket = NULL;
		}
}

void CTsPacketParser::Reset(void)
{
	// pPbgJE^NA
	m_dwErrorPacketCount = 0UL;
	m_dwValidPacketCount = 0UL;

	// pPbgAJE^
	::FillMemory(m_abyContCounter, sizeof(m_abyContCounter), 0x10UL);

	// ԂZbg
	if(m_pOutputPacket)m_pOutputPacket->ClearSize();
	IMediaDecoder::Reset();
}

const DWORD CTsPacketParser::GetInputNum(void) const
{
	return 1UL;
}

const DWORD CTsPacketParser::GetOutputNum(void) const
{
	return 1UL;
}

const bool CTsPacketParser::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex >= GetInputNum())return false;
	if(!pMediaData)return false;

	// TSpPbg
	SyncPacket(pMediaData->GetData(), pMediaData->GetSize());

	// ̓f[^폜
	pMediaData->Delete();

	return true;
}

const DWORD CTsPacketParser::GetErrorPacketCount(void) const
{
	// G[pPbgԂ
	return m_dwErrorPacketCount;
}

const DWORD CTsPacketParser::GetValidPacketCount(void) const
{
	// o̓pPbgԂ
	return m_dwValidPacketCount;
}

void CTsPacketParser::SyncPacket(const BYTE *pData, const DWORD dwSize)
{
	// ̕@͊Sł͂ȂAꂽꍇɑOĂяõf[^܂ł̂ڂĂ͍ē͂łȂ
	DWORD dwCurSize = 0UL;
	DWORD dwCurPos = 0UL;

	while(dwCurPos < dwSize){
		dwCurSize = m_pOutputPacket->GetSize();

		if(!dwCurSize){
			// oCg҂
			for( ; dwCurPos < dwSize ; dwCurPos++){
				if(pData[dwCurPos] == TS_HEADSYNCBYTE){
					// oCg
					m_pOutputPacket->AddByte(TS_HEADSYNCBYTE);
					dwCurPos++;
					break;
					}				
				}
			
			continue;
			}
		else  if(dwCurSize == TS_PACKETSIZE){
			// pPbgTCYf[^

			if(pData[dwCurPos] == TS_HEADSYNCBYTE){
				// ̃f[^͓oCg
				ParsePacket();
				}
			else{
				// G[
				m_pOutputPacket->ClearSize();				
				
				// ʒuɖ߂
				if(dwCurPos >= (TS_PACKETSIZE - 1UL))dwCurPos -= (TS_PACKETSIZE - 1UL);
				else dwCurPos = 0UL;
				}

			continue;
			}
		else{
			// f[^҂
			if((dwSize - dwCurPos) >= (TS_PACKETSIZE - dwCurSize)){
				m_pOutputPacket->AddData(&pData[dwCurPos], TS_PACKETSIZE - dwCurSize);
				dwCurPos += (TS_PACKETSIZE - dwCurSize);
				}	
			else{
				m_pOutputPacket->AddData(&pData[dwCurPos], dwSize - dwCurPos);
				dwCurPos += (dwSize - dwCurPos);
				}			
			
			continue;
			}
		}
}

void CTsPacketParser::ParsePacket(void)
{
	// pPbg͂
	m_pOutputPacket->ParseHeader();

	// pPbg`FbN
	if(m_pOutputPacket->CheckPacket(&m_abyContCounter[m_pOutputPacket->GetPID()])){
		// JEgCNg
		if(m_dwValidPacketCount < 0xFFFFFFFFUL)m_dwValidPacketCount++;

		// ̃fR[_Ƀf[^n
		OutputMedia(m_pOutputPacket);
		m_pOutputPacket = new CTsPacket;
		}
	else{
		// G[JEgCNg
		if(m_dwErrorPacketCount < 0xFFFFFFFFUL)m_dwErrorPacketCount++;

		// G[AZbg
		m_pOutputPacket->ClearSize();
		}
}
